package net.grandnature.android.sdkwg.examples.sensor;

import java.text.DecimalFormat;

import android.app.Activity;
import android.hardware.SensorListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

public class Main extends Activity implements SensorListener {
	View layout;
    TextView accelerometerValue;
    TextView orientationValue;
    TextView filteredAccelerationValue;
    TextView filteredOrientationValue;
    TextView orientation;
    SensorManager sensorManager;
    static DecimalFormat format;
    static {
        format = new DecimalFormat();
        format.applyLocalizedPattern("#0.000");
    }
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        // --- views
        setContentView(R.layout.main);
        layout = findViewById(R.id.layout);
        accelerometerValue = (TextView)findViewById(R.id.accelerometer_value);
        orientationValue = (TextView)findViewById(R.id.orientation_value);
//        filteredAccelerationValue = (TextView)findViewById(R.id.filtered_acceleration_value);
//        filteredOrientationValue = (TextView)findViewById(R.id.filtered_orientation_value);
//        orientation = (TextView)findViewById(R.id.orientation);

        // --- sensors
        sensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
    }
	@Override
	protected void onStop() {
		sensorManager.unregisterListener(this);
		super.onStop();
	}
	@Override
	protected void onResume() {
		super.onResume();
        sensorManager.registerListener(this, 
                SensorManager.SENSOR_ACCELEROMETER | 
                SensorManager.SENSOR_ORIENTATION,
                SensorManager.SENSOR_DELAY_FASTEST);
	}
//	private float[] currentOrientationValues = {0.0f, 0.0f, 0.0f};
//	private float[] currentAccelerationValues = {0.0f, 0.0f, 0.0f};
	public void onSensorChanged(int sensor, float[] values) {
		switch(sensor) {
		case SensorManager.SENSOR_ACCELEROMETER:
			accelerometerValue.setText(convertFloatsToString(values));
			break;
		case SensorManager.SENSOR_ORIENTATION:
			orientationValue.setText(convertFloatsToString(values));
			break;
		default:
		}
	}
	private String convertFloatsToString(float[] values) {
		return 
		String.valueOf(format.format(values[0])) + ", " + 
		String.valueOf(format.format(values[1])) + ", " + 
		String.valueOf(format.format(values[2]));
		
	}
	public void onAccuracyChanged(int sensor, int accuracy) {
		// TODO Auto-generated method stub
		
	}
}